#include "prescan.h"

int make_keypkt(char *, char,int);
int dns_connect(struct host *);
int dns_check(struct host *);
void find_dns_reply(struct host *, char *);

int make_keypkt(char *pktbuf, char opc,int sock)
{
   HEADER *dnsh;
   char *ptr = pktbuf;
   int pktlen = 0;

   dnsh = (HEADER *) ptr;
   /* fill out the parts of the DNS header that aren't 0 */
   dnsh->id = htons(rand() % 65535);
   dnsh->opcode = opc;
   dnsh->rd = 1;
   dnsh->ra = 1;
   /* one answer for IQUERY, one question for QUERY */
   if (opc == IQUERY)
      dnsh->ancount = htons(1);
   else if (opc == QUERY)
      dnsh->qdcount = htons(1);
   pktlen += sizeof(HEADER);
   ptr += sizeof(HEADER);

   /* we have to make a QUERY, fill out the question section */
   if (opc == QUERY)
     {
        /* version.bind. == elite */
        char qstr[] = "\007version\004bind\000";
        int qlen = strlen(qstr) + 1;

        memcpy(ptr, qstr, qlen);
        ptr += qlen;
        pktlen += qlen;
        PUTSHORT(T_TXT, ptr);
        PUTSHORT(C_CHAOS, ptr);
        pktlen += sizeof(short) * 2;
     }
   /* add a resource record for the inverse query */
   else if (opc == IQUERY)
     {
        unsigned long addr = inet_addr("1.2.3.4");
        unsigned long ttl = 31337;
        unsigned short addrlen = 4;

        *(ptr++) = '\0';
        pktlen++;
        PUTSHORT(T_A, ptr);
        PUTSHORT(C_IN, ptr);
        PUTLONG(ttl, ptr);
        PUTSHORT(addrlen, ptr);
        PUTLONG(addr, ptr);
        pktlen += (sizeof(short) * 3) + (sizeof(long) * 2);
     }
   /* if we're debugging, show what we just made */
   
   write(sock,pktbuf,pktlen);
   
   return pktlen;
}

int dns_connect(struct host *victim)
{
  victim->udp_sock = nonblock_udp_connect(victim->ip,53);
  ++victim->udp_sock_tool;
}

int dns_check(struct host *victim)
{
  int retval;
  char *buf=NULL,*packet=NULL;

  retval = sock_status(victim->udp_sock);
  
  /* UDP Connection established, send IQUERY */
  if(retval == 0 && victim->udp_sock_tool == 1)
  {
    ++victim->udp_sock_tool;
    packet = (char*) Malloc(512);
    memset(packet,0,512);    
    make_keypkt(packet, IQUERY,victim->udp_sock);
    Free(packet);
  }
  /* Found response too IQUERY, send QUERY */
  else if(retval > 0 && victim->udp_sock_tool == 2)
  {
    ++victim->udp_sock_tool;
    buf = (char*) Malloc(retval+1);
    memset(buf,0,(retval+1));
    read(victim->udp_sock,buf,retval);
    packet = (char*) Malloc(512);
    memset(packet,0,512);
    make_keypkt(packet, QUERY,victim->udp_sock);
    Free(packet);
    Free(buf);
  }
  /* Found response to QUERY, parse data and save bind version */
  else if(retval > 0 && victim->udp_sock_tool == 3)
  {
    buf = (char*) Malloc(retval+1);
    memset(buf,0,(retval+1));
    read(victim->udp_sock,buf,retval);
    find_dns_reply(victim,buf);
    victim->udp_sock_tool = -1;
    Free(buf);
  }
  if(victim->udp_sock_tool == -1)
  {
    close(victim->udp_sock);
  }
  return 0;
}

void find_dns_reply(struct host *victim, char *buf)
{
   HEADER *dnsh = (HEADER *)buf;
   char *ptr, *verstr;
   int len;

   if (dnsh->rcode != 0)
        return;
   /* So we actually have a response.  Lets skip the crap, starting with the header */
   ptr = (buf + sizeof(HEADER));
   /* then the question section domain name. */
   while (*ptr != '\0')
     ptr++;
   /* then the trailing null and the type/class of the question */
   ptr += 1 + (sizeof(short) * 2);
   /* now we skip the answer section domain name. (should be the same as the question) */
   while (*ptr != '\0')
     ptr++;
   /* don't forget the trailing null, type, class, and time to live. */
   ptr += 1 + (sizeof(long) + (sizeof(short) * 2));
   /* Here we are at the resource record data length, extract it */
   GETSHORT(len, ptr);
   /* avoid the need to decompress the string (treat it as one) */
   ptr++;
   /* allocate space for and copy the version response txt */
   verstr = (char *)malloc(len);
   memset(verstr, 0, len);
   memcpy(verstr, ptr, len-1);
   /* run through the vesion string and replace non-printable and non-whitespace characters
      with a '.' */
   for (ptr = verstr; ptr - verstr != len - 1; ptr++)
      if (!isprint(*ptr) && !isspace(*ptr))
         *ptr = '.';
   /* print the version and iquery support status, woo hoo */

   victim->bind_version = (char*) Malloc(strlen(verstr)+1);
   sprintf(victim->bind_version,"%s\0",verstr);
  if(config.debug)
    printf("[DNS] Found bind version: %s\n",verstr);
   
}
