#include "prescan.h"

int prescan(struct host *);

int prescan(struct host *victim)
{
  int i,timer;

  /* FIND NAME/IP FROM HOSTNAME */
  forward_lookup(victim);
  if(!config.r_lookup) reverse_lookup(victim);

  if(!victim->ip)
  {
    printf("Error looking up hostname: %s\n",victim->host);
    return -1;  /* couldn't find an IP from the hostname */
  }

  printf("SCANNING: %s (%s)\n",
         Inet_ntoa(victim->ip),
         (victim->name ? victim->name:"no dns entry found") );

  victim->scan_time = time(NULL);

  /* INIT: PING */
  if(!config.stealth && config.got_root)
    if(send_icmp_echo(victim) < 0)
      perror("send_icmp_echo() failed");

  /* INIT: TCP (OR SYN SCAN) */
  for(i=0 ; config.port[i] != 0 ; ++i,usleep(700))
    add_tcp((SYN_SOURCE+i),config.port[i],victim);
    
  timer = (time(NULL) + config.timeout);
  
  /* START: CHECKING FOR INCOMING DATA */
  while(time(NULL) < timer)
  {
    if(!config.stealth)
    {
      /* CHECK: Non-blocking tcp port scanning and banner checking */
      if(tcp_check(victim))
        timer = (time(NULL) + (config.timeout));

      /* CHECK: Non-blocking UDP DNS query */
      if(dns_check(victim))
        timer = (time(NULL) + (config.timeout));      
    }
    /* CHECK: Ping response and TCP stack fingerprints */
    if(config.got_root)
      if(sniff(victim))
        timer = (time(NULL) + (config.timeout));
  }   
  return 1;
}
