#include "prescan.h"

void talk_with_protocol(struct host *);
void talk_imap(struct host *);
void talk_smtp(struct host *);
void talk_pop3(struct host *);
void talk_telnet(struct host *);
void talk_http(struct host *);
void talk_ftp(struct host *);
void talk_dns(struct host *);

static int telnet_banner_len;

void talk_with_protocol(struct host *victim)
{
  /* FIND THE PROTOCOL, TALK TO IT. */
  if(config.debug)
    printf("[%d] PROTOCOL TALK.\n",victim->tcp_current->port);

  if(victim->tcp_current->port == 23) talk_telnet(victim);
  else if(victim->tcp_current->port == 25) talk_smtp(victim);
  else if(victim->tcp_current->port == 143) talk_imap(victim);
  else if(victim->tcp_current->port == 110) talk_pop3(victim);
  else if(victim->tcp_current->port == 80) talk_http(victim);
  else if(victim->tcp_current->port == 21) talk_ftp(victim);
  //else if(victim->tcp_current->port == 53) talk_dns(victim);
  else
    tcp_close(victim->tcp_current);

  if(config.debug)
    printf("[%d] PROTOCOL TALK END.\n",victim->tcp_current->port);
}

void talk_dns(struct host *victim)
{
  tcp_close(victim->tcp_current);
  dns_connect(victim);
}

void talk_ftp(struct host *victim)
{
  /* ftp communication */

  char *ptr;
  int retval;

  if(victim->tcp_current->datalen == 0) return; /* we're waiting for the banner.. */

  ptr = (char*)Malloc(victim->tcp_current->datalen + 1);
  retval = readline_from_sock(victim->tcp_current->sock,ptr,victim->tcp_current->datalen);
  victim->tcp_current->datalen -= retval;

  if(strncmp(ptr,"220-",4) == 0) return;

  else if(strncmp(ptr,"220 ",4) == 0 && victim->ftp_banner == NULL)
  {
    /* BANNER FOUND */
    victim->ftp_banner = (char*) Malloc(strlen(ptr) + 1);
    strcpy(victim->ftp_banner,ptr);
    victim->ftp_banner[strlen(victim->ftp_banner) - 1] = 0;
    /* SEND SYST COMMAND */
    write(victim->tcp_current->sock,FTP_SYST,strlen(FTP_SYST));
    /* SEND ANONYMOUS LOGIN */
    write(victim->tcp_current->sock,FTP_USER,strlen(FTP_USER));
  }
  else if(strncmp(ptr,"215 ",4) == 0)
  {
    /* SYST REPLY FOUND */
    victim->ftp_syst = (char*) Malloc(strlen(ptr) + 1);
    strcpy(victim->ftp_syst,ptr);
    victim->ftp_syst[strlen(victim->ftp_syst) - 1] = 0;
  }
  else if(strncmp(ptr,"331 ",4) == 0)
    write(victim->tcp_current->sock,FTP_PASS,strlen(FTP_PASS));
  else if(strncmp(ptr,"230 ",4) == 0)
  {
    if(config.debug)
      printf("[21] ANONYMOUS SUPPORTED\n");
    victim->anonymous_ftp = 1;
    tcp_close(victim->tcp_current);
  }
  else if(strncmp(ptr,"530 ",4) == 0)
  {
    if(config.debug)
      printf("[21] NO ANONYMOUS LOGINS\n");
    victim->anonymous_ftp = 0;
    tcp_close(victim->tcp_current);
  }

  free(ptr);

  return;

}

void talk_imap(struct host *victim)
{
  /* imap communication */
  int retval;

  if(victim->tcp_current->datalen == 0) return;   /* we're waiting for the banner.. */

  victim->imap_banner = (char*) Malloc(victim->tcp_current->datalen + 1);
  retval = readline_from_sock(victim->tcp_current->sock,victim->imap_banner,victim->tcp_current->datalen);

  if(config.debug)
    printf("IMAP RETVAL: %d\n",retval);

  if(strlen(victim->imap_banner) > 1)
    victim->imap_banner[strlen(victim->imap_banner) - 1] = 0;

  tcp_close(victim->tcp_current);

}

void talk_smtp(struct host *victim)
{
  /* smtp communication */
  int retval;

  if(victim->tcp_current->datalen == 0) return;   /* we're waiting for the banner.. */

  victim->smtp_banner = (char*) Malloc(victim->tcp_current->datalen + 1);
  retval = readline_from_sock(victim->tcp_current->sock,victim->smtp_banner,victim->tcp_current->datalen);

  if(config.debug)
    printf("SMTP RETVAL: %d\n",retval);

  if(strlen(victim->smtp_banner) > 1)
    victim->smtp_banner[strlen(victim->smtp_banner) - 1] = 0;

  tcp_close(victim->tcp_current);
}

void talk_pop3(struct host *victim)
{
  /* pop3 communication */
  int retval;

  if(victim->tcp_current->datalen == 0) return;   /* we're waiting for the banner.. */

  victim->pop3_banner = (char*) Malloc(victim->tcp_current->datalen + 1);
  retval = readline_from_sock(victim->tcp_current->sock,victim->pop3_banner,victim->tcp_current->datalen);

  if(config.debug)
    printf("POP3 RETVAL: %d\n",retval);

  if(strlen(victim->pop3_banner) > 1)
    victim->pop3_banner[strlen(victim->pop3_banner) - 1] = 0;

  tcp_close(victim->tcp_current);
}

void talk_telnet(struct host *victim)
{
  /* telnet communication */
  unsigned char output[4];
  unsigned char *ptr=NULL,*ptr2=NULL;
  unsigned char *string=NULL;

  if(victim->tcp_current->datalen < 1) return;

  string = (char*) Malloc(victim->tcp_current->datalen + 1);
  bzero(string,victim->tcp_current->datalen + 1);
  read(victim->tcp_current->sock,string,victim->tcp_current->datalen);

  for (ptr=string ; victim->tcp_current->datalen > 0 ; ++ptr,--victim->tcp_current->datalen)
  {
    if (*ptr == 255)	/* 0xff (255) == "interpret as command" in telnet.. */
    {
      ++ptr;  /* move to the next byte for comparison. */
      if (*ptr == 253)	/* 253 == "DO" in telnet. */
      {
        ++ptr;  /* move to the third and final byte (the option type) */

        output[0] = 255;
        output[1] = 252; /* 252 == "WONT" in telnet. */
        output[2] = *ptr;   /* whatever the option type was.. */
        write (victim->tcp_current->sock, output, 3);
      }
      victim->tcp_current->datalen -= 2;  /* subtract the extra 2 bytes we read */
    }
    else if(!isprint(*ptr) && !isalpha(*ptr) && !isdigit(*ptr) && !isspace(*ptr)) continue;
    else
    {
      /* FOUND THE BANNER. */
      if(victim->telnet_banner == NULL)
      {
        telnet_banner_len = strlen(ptr);
        victim->telnet_banner = (char*) Malloc(telnet_banner_len + 1);
        strncpy(victim->telnet_banner,ptr,telnet_banner_len);
        victim->telnet_banner[telnet_banner_len] = 0;
      }
      else
      {
        victim->telnet_banner = (char*) realloc(victim->telnet_banner,strlen(ptr) + telnet_banner_len + 1);
        ptr2 = victim->telnet_banner;
        ptr2 += telnet_banner_len;
        strncpy(ptr2,ptr,strlen(ptr));
        ptr2[strlen(ptr)] = 0;
        telnet_banner_len += strlen(ptr);
      }

      /* SLACKER PROMPT DETECTION... */
      if(    strstr(victim->telnet_banner,"ogin:")
          || strstr(victim->telnet_banner,"assword:")
          || strstr(victim->telnet_banner,"sername:")
          || strstr(victim->telnet_banner,"Wingate>") )
      {
        tcp_close(victim->tcp_current);
      }


      victim->tcp_current->datalen = 0;

    }   /* end of "printable character" if() statement... */


  }   /* end of FOR loop, all data has been handled. */

  free(string);
}


void talk_http(struct host *victim)
{
  /* http communication */
  char *line,*ptr;
  int retval;

  if(victim->tcp_current->datalen == 0)
  {
    write(victim->tcp_current->sock,HTTP_REQUEST,strlen(HTTP_REQUEST));
    return;
  }
  while(victim->tcp_current->datalen != 0)
  {
    line = (char*) Malloc(256);
    retval = readline_from_sock(victim->tcp_current->sock,line,256);
    if(retval < 0) return;
    victim->tcp_current->datalen -= retval;

    if((strncasecmp(line,"Server:",7)) == 0)
    {
      ptr = strchr(line,' '); ++ptr;

      /* SAVE SERVER TYPE... */
      victim->http_server = (char *) Malloc(strlen(ptr) + 1);
      strcpy(victim->http_server,ptr);
      victim->http_server[strlen(victim->http_server) - 1] = 0;

      tcp_close(victim->tcp_current);
      free(line);
      break;
    }
  }
}
