#include "prescan.h"

/* reminders: always return 'retval'. */

int sniff(struct host *);

int sniff(struct host *victim)
{

  int i=0,retval=0;
  char *ptr;

  struct iphdr *ip;
  struct tcphdr *tcp;

  for(i=0; i != 30 ; ++i) /* 30 = maximum number of packets to handle before returning. */
  {
    ptr=(char*)next_packet();
    if(!ptr) return retval;

    ip = (struct iphdr*) ptr;
    if(ip->saddr != victim->ip) continue;   /* make sure its from the correct host */

    /* ICMP */
    if(ip->protocol == IPPROTO_ICMP)
    {
      /* Even though we found an ICMP response from the host, don't
          return retval=1, because this will reset the timeout timer.
          Only TCP data resets the timer */

      if(config.debug)
        printf("PING REPLY FOUND.\n");

      victim->ping_reply = 1;

      continue;
    }

    /* TCP (STACK FINGERPRINTS, SYN SCAN) */
    if(ip->protocol == IPPROTO_TCP)
    {
      tcp = (struct tcphdr*) (ptr+20);

      /* SYN SCAN */
      if(config.stealth)
      {
        for(victim->tcp_current=victim->tcp_first;victim->tcp_current;victim->tcp_current=victim->tcp_current->next)  
          if(ntohs(tcp->source) == victim->tcp_current->port)
          {
            /* OPEN */
            if(tcp->ack && tcp->syn)
            {
              if(config.debug)
                printf("[SYN] PORT OPEN: %d\n",victim->tcp_current->port);
              victim->tcp_current->open = 1;
              victim->tcp_current->state = CONNECTED;
              if(!victim->osdetect_tool)
              {
                init_osdetect(victim);
                victim->osdetect_tool = 1;
              }
            }
            /* REJECTED */
            if(tcp->ack && tcp->rst)
            {
              if(config.debug)
                printf("[SYN] PORT CLOSED: %d\n",victim->tcp_current->port);
              victim->tcp_current->state = REJECTED;
            }
            
          }
      
      }
        
      /* OS DETECTION */
      switch(ntohs(tcp->dest))
      {
        case PORT_1:
          handle_response(victim,0,tcp);
          retval = 1;
          break;

        case PORT_2:
          handle_response(victim,1,tcp);
          retval = 1;
          break;

        case PORT_3:
          handle_response(victim,2,tcp);
          retval = 1;
          break;

        case PORT_4:
          handle_response(victim,3,tcp);
          retval = 1;
          break;

        case PORT_5:
          handle_response(victim,4,tcp);
          retval = 1;
          break;

          default:
          ++i;
          continue;
      }
    }
  }
  return retval;
}
